// file: mweights.cc

// read in network descriptions
  
/* the following is the form for network description files:

definitions:
nunits <int>   Anzahl Units
ninputs <int>  Anzahl Eingabeunits
noutputs <int> Anzahl Ausgabeunits
nepochs <int>  Anzahl der Lernepochen
ecrit <double>  Abbruchkriterium beim Lernen: tss <= ecrit
wrange <double> Initialisierungsbereich fr Gewichte
alpha <double> Lernrate
dgrain <*char> [PATTERN/EPOCH] regelt Display-Update
lgrain <*char> [pattern/epoche]
lflag <int>    1=Lernen; 0=Nicht-Lernen
pchoose <*char> gibt an, in welcher Reihenfolge die Trainingsmuster verwendet
                werden sollen: random/serial
network:
<strings of . and chars as defined in definitions:>
end
biases:
<a single line of . and chars as biases for units>
end
<EOF>
fms:
lambda	zur globalen Initialisierung von lambda (s. alpha)
delta_lambda    Wert fuer Anpassung von lambda
lparam_update	Anzahl der Epochen nach denen die Lernparameter angepasst werden
K Genauigkeit der Gewichte
tpatterns       Gewichtsupdate nach tpatterns Mustern
end
settings:
statlog on/off	Gewichts-Logging on/off
gamma	Glaettungsparameter fuer E_a
display on/off  Anzeige ein-/ausschalten
end
*/

#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <ctype.h>
#include <sys/time.h>
#include "general.h" // muss vor weights.h stehen!!
#include "mweights.h"

class Gewicht {
public:
double a; // nur zum testen
Gewicht(); // Konstruktor
~Gewicht(); // Destruktor
};



double **weight;
char   **wchar; // Pointer auf char-Vektoren zum Gewichte setzen
char   *bchar;        // wie wchar
double alpha;
double  balpha;  // 
double  **wed;

// neu fuer FMS *********************************************************
double lambda; // Lernrate fuer Aktivierungskostenterm
double K; // Genauigkeit der Gewichte
// **********************************************************************

double   wrange = 0.1;

int nunits = 0;
int ninputs = 0;
int noutputs = 0;
int nlinks = 0;
char net_name[BUFSIZ];

long old_epochs=0;// zum Fortsetzen nach Ende der vorgegebenen Durchlaeufe

int bp = 1; 
// TRUE wenn bp

ifstream net_def;

# define ENLARGE_POS -1
# define ENLARGE_NEG -2

Gewicht::Gewicht() // Konstruktor
{
}

Gewicht::~Gewicht() // Destruktor
{
}


boolean starts(char *s1, char *s2)// normalerweise in general.cpp
// faengt s1 genauso an wie s2?
{
  while (*s1 && *s2) {
    if (*s1++ != *s2++)
      return(FALSE);
  }
  if(*s1 && !*s2)  // wenn s1 laenger ist als s2 soll die Fkt. FALSE liefern
    return(FALSE);
  return(TRUE);
}

void define_bp_network() {
  bp = 1;
  define_net();
}

// wird nicht benutzt!!!
void define_network() {
  bp = 0;
  define_net();
}

// zum einlesen der Netzwerkbeschreibung
// genaues Format in weights.cc!!!
int define_net() {
  char   *sp=new char [BUFSIZ];
  char    string[BUFSIZ];

  cout << "\n Body fuer Dateiname fuer Netzwerk: ";
  cin >> net_name;
  if ( net_name == NULL) return(CONTINUE);
  strcpy(sp, net_name);
  
  strcat(sp, ".net");  

  net_def.open(sp);
  if (net_def.fail()) {
    put_error("\nFehler beim Oeffnen der Netzwerkbeschreibungsdatei: ");
    return(BREAK); // Datei nicht vorhanden
  }

  #ifdef DEBUG
  cout << "\nweights|define_net()";
  #endif
  nlinks = 0;

  // DEFINITIONS
  while (!net_def.eof()) { 
    net_def >> string;
    if (!strcmp(string, "definitions:")) {
      if (read_definitions() == BREAK) {
        net_def.close();
        return(BREAK);
      }
    }
    else
    // NETWORK                 
    if (!strcmp(string, "network:")) {
      if (read_network()==BREAK) {
        put_error(err_string);
        net_def.close();
        return(BREAK);
      }
    }
    else
    // FMS                 
    if (!strcmp(string, "fms:")) {
      if (read_fms() == BREAK) {
        put_error(err_string);
        net_def.close();
        return(BREAK);
      }
    }
    else
    if (!strcmp(string, "biases:")) {
      if (read_biases() == BREAK) {
        put_error("Fehler beim Lesen der Bias-Definition."); 
        return(BREAK);
      }
    }
    else
    // Programm-Einstellungen                 
    if (!strcmp(string, "settings:")) {
      if (read_settings()==BREAK)
        return(BREAK);
    }
    else
    if (!strcmp(string, "end")) {
    // just skip over it
    }
    else
    if (!net_def.eof())  {
      sprintf(err_string,
        "Fehler beim Lesen der Netzwerkbeschreibungsdatei:  %s unbekannt\n",string);
      put_error(err_string);
      return(BREAK);
    }
  }
  return(CONTINUE);
}

int read_definitions() {
  char string[BUFSIZ];
  double temp;
  
  #ifdef DEBUG
  cout << "\nweights|read_definitions()"; 
  #endif

  while (!net_def.eof()) {
    net_def >> string;
    if (!strcmp(string, "end")){
      return(CONTINUE);
    }
    else                    
    if (starts(string, "nunits")) {
      #ifdef DEBUG
      cout << "\n1" << string << "|";
      #endif
      net_def >> nunits;                 // nunits
      #ifdef DEBUG
      cout << nunits;
      #endif
    }
    else
    if (starts(string, "lflag")) {
      #ifdef DEBUG
      cout << "\n2 1" << string << "|";
      #endif
      net_def >> lflag;                 // lflag
      #ifdef DEBUG
      cout << lflag;
      #endif
    }
    else
    if (starts(string, "ecrit")) {
      #ifdef DEBUG
      cout << "\n2" << string << "|";
      #endif
      net_def >> temp;                    // ecrit
      #ifdef DEBUG
      cout << temp;
      #endif
      ecrit=temp;
    }
    else
    if (starts(string, "ninputs")) {
      #ifdef DEBUG
      cout << "\n3" << string << "|";
      #endif
      net_def >> ninputs;                    // ninputs
      #ifdef DEBUG
      cout << ninputs;
      #endif
    }
    else
    if (starts(string, "nepochs")) {
      #ifdef DEBUG
      cout << "\n3 1" << string << "|";
      #endif
      net_def >> nepochs;                    // nepochs
      #ifdef DEBUG
      cout << nepochs;
      #endif
    }
    else
    if (starts(string, "noutputs")) {
      #ifdef DEBUG
      cout << "\n4" << string << "|";
      #endif
      net_def >> noutputs;                    // noutputs
      #ifdef DEBUG
      cout << noutputs;
      #endif
    }
    else
    if (starts(string, "wrange")) {
      #ifdef DEBUG
      cout << "\n5" << string << "|";
      #endif
      net_def >> wrange;                    // wrange
      #ifdef DEBUG
      cout << wrange;
      #endif
    }
    else
    if (starts(string, "alpha")) {
      #ifdef DEBUG
      cout << "\n7" << string << "|";
      #endif
      net_def >> alpha;                    // alpha
      #ifdef DEBUG
      cout << alpha;
      #endif
    }
    else
    if (starts(string, "lgrain")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> string;                    // lgrain
      if (starts(string,"epoche" )) {
        strcpy(grain_string,"epoche");
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else 
      if (starts(string,"pattern")){
        strcpy(grain_string,"pattern");
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else {
        return(put_error("Unbekannte Lernart  -- (epoche/pattern)."));
      }      
    }
    else
    if (starts(string, "dgrain")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> string;                    // dgrain
      if (starts(string,"epoche" )) {
        step_size = EPOCH;
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else 
      if (starts(string,"pattern")){
        step_size = PATTERN;
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else {
        return(put_error("Unbekannte Display-Art  -- (EPOCH/PATTERN)."));
      }      
    }
    else 
    if (starts(string, "pchoose")) {
      #ifdef DEBUG
      cout << "\n8" << string << "|";
      #endif
      net_def >> string;                    // pchoose
      if (starts(string,"random" )) {
        strcpy(choose_string,"random");
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else 
      if (starts(string,"serial")) {
        strcpy(choose_string,"serial");
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else {
        return(put_error("Unbekannte Auswahlart  -- (random/serial)."));
      }      
    }
    else {
      return(put_error("Unbekannter Wert  -- read_definitions."));
    }//else 
  }
  return(CONTINUE);
}

int read_network()
{
  int     r,s,block;
  int     rstart,rnum,rend,sstart,snum,send;
  char    all_ch;
  char    string[BUFSIZ];
  int     needline = 1;
  struct timeval *tp=new timeval;
  struct timezone *tz = NULL;      

  #ifdef DEBUG
  cout << "\nweights|read_network()";
  #endif

  gettimeofday(tp, tz);
  srandom((int)(tp->tv_sec));

  weight = new double *[nunits];
    
  wchar = new char *[nunits];

  // ***********************************************
  rstart = 0; rend = nunits -1; sstart = 0; send = nunits -1;
  for (block = 0; ; block++) {
    // hier geht's Einlesen der Netzwerkdefinition los ************************
    if (net_def.eof()) {
      sprintf(err_string,"Fehler in der Netzwerkbeschreibung. Unvorhergesehenes Dateiende.");
      return(FALSE);
    }
    // Zuweisung!!
    net_def >> string;
    if (strcmp(string, "end")==0){
      if (block) 
        return(CONTINUE);
      else 
      {
        sprintf(err_string,"Fehler in der Netzwerkbeschreibung.(1)");
        return(BREAK);
      }
    }

    all_ch = '\0';
    // Netzwerkbeschreibung als Block!!! in der Form "%r nn nn nn nn"
    if (string[0] == '%') {
      net_def >> rstart >> rnum >> sstart>> snum;
      rend = rstart + rnum -1;
      send = sstart + snum -1;
      if (string[1]) {
        all_ch = string[1];
      }
    }
    else {
      if (!block) {
        needline = 0;
      }
      else {
        sprintf(err_string,"Fehler in der Netzwerkbeschreibung.(2)");
        return(FALSE);
      }
    }
    for (r = 0; r < nunits; r++) {
      weight[r] = new double [nunits+1];// +1 wg. bias
      wchar[r] = new char [nunits];
      // FMS ****************
      // ********************
      for(s = 0; s < nunits; s++) {
        // now set up the char based on the stored con definitions
        if (((s<ninputs)&&((r<nunits-noutputs)&&(r>=ninputs)))||(((s>=ninputs)&&(s<nunits-noutputs))&&(r>=nunits-noutputs)))
          weight[r][s] = (wrange * rnd()) - (.5*wrange);
        else
          weight[r][s] = 0.0;// Gewichte, die in der Architektur niht vorkommen, werden auf 0 gesetzt
        wchar[r][s] = '.';
      }
      // Standard-bias-Initialisierung
      weight[r][nunits]=-1.0; // bias-gewicht!
    }
  }
}

int read_biases()
{
  int     j,rstart,rend,rnum,block;
  char    ch,all_ch,*strp;
  char    string[BUFSIZ];
  boolean ok;

  bchar = new char [nunits];

  for (j = 0; j < nunits; j++) {
    weight[j][nunits] = 1.0;
    bchar[j] = '.';
  }

  rstart = 0; rend = nunits -1;
  ok=FALSE;
  for (block = 0; !ok; block++) {
    while (!ok) {
    if (net_def.eof()) {
      sprintf(err_string,"Fehler in der Biasbeschreibung. Unvorhergesehenes Dateiende.");
      return(BREAK);
    }
    // Zuweisung!!
    net_def >> string;
    if (strcmp(string,"end") == 0) {
        //if (block) 
          return (CONTINUE);
        //else return(put_error("Problem in der Bias-Beschreibung"));
    }
    // Biasbeschreibung als Block!!! in der Form "%r nn nn"
    if (string[0] == '%') {
      net_def >> rstart >> rnum;
      rend = rstart + rnum -1;
      ok=TRUE;
      if (string[1] != '\0') {
        all_ch = string[1];
        for (j = 0; j < rnum; j++) {
          string[j] = all_ch;
        }
        string[j] = '\0';
        ok=TRUE;
      }
      else ok=FALSE;
    }
    } // while ()
    for (strp = string, j = rstart; j <= rend; j++, strp++) {
      ch = *strp;
      bchar[j] = ch;
      if (ch == '.') {
        weight[j][nunits] =-1.0;
        balpha = alpha;
      }
      else {
        // erstmal sehn, ob's wirklich ein Zeichen ist
        if (!isalpha(ch)) {
          return(put_error("Falsches Zeichen im Bias."));
        }
        balpha = alpha;
        if (j>=ninputs)
          weight[j][nunits] = (wrange * rnd()) -(.5*wrange);
      }
    }
  }
  // bias auf 1 setzen
  for (j = ninputs; j < nunits; j++) {
    weight[j][nunits] =-1.0;
  }
  return(CONTINUE);
}                        


int write_weights() {
  int     i,j;
  char fname[BUFSIZ];
  ofstream weight_file;
  boolean datei_ok = FALSE;
  
  if (weight == NULL) {
    return(put_error("Undefiniertes Netz kann nicht gespeichert werden."));
  }
  #ifdef DEBUG
  cout << "\nweights|write_weights()";
  #endif

  
  strcpy(fname, net_name);

  strcat(fname, ".gew");  

  if (fname == NULL) 
    return(CONTINUE);
   
  do
  {
    weight_file.open(fname);
    if (weight_file.fail()) {
      put_error("\nFehler beim Oeffnen der Gewichtsdatei.");
      return(BREAK); // Datei nicht vorhanden
    }
    datei_ok=TRUE;
  }
  while (!datei_ok);
  
  for (i = 0; i < nunits; i++) {
    for (j = 0; j < nunits; j++) {
      #ifdef DEBUG
      cout << "\nSchreibe Gewicht [" << i << "][" << j << "]: " << weight[i][j];
      #endif
      weight_file << "[" << i << "][" << j << "] "<< weight[i][j] <<"\n";
    }
  }

  write_bias();

  weight_file << lambda << "\n";
  weight_file << epochno+old_epochs << "\n";
  weight_file.close();
  return(CONTINUE);
}

int write_bias()
{
  int     i;
  char fname[BUFSIZ];
  ofstream bias_file;
//  boolean datei_ok = FALSE;

  
  strcpy(fname, net_name);

  strcat(fname, ".bs");  
  if (fname == NULL) 
    return(CONTINUE);
   
  bias_file.open(fname);
  if (bias_file.fail()) {
    put_error("\nFehler beim Oeffnen der Biasdatei.");
    return(BREAK); // Datei nicht vorhanden
  }
  
  for (i = 0; i < nunits; i++) {
    #ifdef DEBUG
    cout << "\nSchreibe Bias [" << i << "]: " << weight[i][nunits];
    #endif
    bias_file << weight[i][nunits] <<"\n";
  }
  
  bias_file << epochno;
  
  bias_file.close();
  return(CONTINUE);
}

int read_weights() {
// liest Gewichtsdaten aus einer Textdatei
  int     i,j;
  ifstream weight_file;
  char *fname=new char [BUFSIZ];

  
  char str[BUFSIZ], tempstr[BUFSIZ];
  ifstream epoch;
  // old_epochs einlesen
  strcpy(str, net_name);
  strcat(str, ".dsp");
  epoch.open(str);
  if (epoch.fail()) 
  {
    cout << "fehler bei stream oeffnen.";
  }
  while (!epoch.eof())
  {
    epoch >> tempstr;
    if (starts(tempstr, "Epoche:")) {
      epoch >> old_epochs;
      break;
    }
  }

  epoch.close();

  // *******************
  strcpy(fname, net_name);
  strcat(fname, ".gew");  

  #ifdef DEBUG
  cout << "\nweights|read_weights()";  
  #endif

  if(!System_Defined)
     return(BREAK);

  if (weight == NULL) {
    return(put_error("Undefiniertes Netz kann nicht wiederhergestellt werden."));
  }
    
  if(fname == NULL)  return(BREAK);

  weight_file.open(fname);
  if (weight_file.fail()) {
    put_error("Fehler beim Oeffnen der Gewichtsdatei: ");
    return(BREAK); // Datei nicht vorhanden
  }
 
  for (i = 0; i < nunits; i++) {
    for (j = 0; j < nunits; j++) {
      weight_file >> fname; // Indizes lesen und wegwerfen
      weight_file >> weight[i][j];
      if (weight_file.eof()) {
        return(put_error("Gewichtsdatei ist nicht korrekt fuer dieses Netzwerk"));
      }
    }
  }
 
  read_bias();

  // FMS spezielle Parameter fuer FMS einlesen
  // lambda, 
  weight_file >> lambda;

  return(CONTINUE);
}

int read_bias() 
{
  int     i;
  char fname[BUFSIZ];
  ifstream bias_file;
  
  strcpy(fname, net_name);

  strcat(fname, ".bs");  
  if (fname == NULL) 
    return(CONTINUE);
   
  bias_file.open(fname);
  if (bias_file.fail()) {
    put_error("\nFehler beim Oeffnen der Biasdatei.");
    return(BREAK); // Datei nicht vorhanden
  }

  for (i = 0; i < nunits; i++) {
    bias_file >> weight[i][nunits];
    if (bias_file.eof()) {
      return(put_error("Biasdatei ist nicht korrekt fuer dieses Netzwerk. Beim Lesen der Bias-Daten."));
    }
  }
  return(CONTINUE);
}
  

int read_settings() {
  char string[BUFSIZ];
//  double temp;
  
  #ifdef DEBUG
  cout << "\nweights|read_settings()"; 
  #endif

  while (!net_def.eof()) {
    net_def >> string;
    if (!strcmp(string, "end")){
      return(CONTINUE);
    }
    else
    if (starts(string, "gamma")) {
      #ifdef DEBUG
      cout << "\n4" << string << "|";
      #endif
      net_def >> E_gamma;                    // gamma
      #ifdef DEBUG
      cout << E_gamma;
      #endif
    }
    else
    if (starts(string, "display")) {
      #ifdef DEBUG
      cout << "\n4" << string << "|";
      #endif
      net_def >> string;                    // display
      if (starts(string,"on" )) {
        nodisplay=FALSE;
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else 
      if (starts(string,"off")){
        nodisplay=TRUE;
        #ifdef DEBUG
        cout << string;
        #endif
      }
      else {
        return(put_error("DISPLAY-Einstellung"));
      }      
    }
    else
    if (starts(string, "statlog")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> string;                    // statlog
      if (starts(string,"on" )) {
        statlog=TRUE;
        #ifdef DEBUG
        cout << statlog;
        #endif
      }
      else 
      if (starts(string,"off")){
        statlog=FALSE;
        #ifdef DEBUG
        cout << statlog;
        #endif
      }
      else {
        return(put_error("STATLOG-Einstellung"));
      }      
    }
    else {
      return(put_error("Unbekannter Wert  -- read_settings."));
    }//else 
  }
  return(CONTINUE);
}

int read_fms() {
  char string[BUFSIZ];
//  int r, s;
  
  #ifdef DEBUG
  cout << "\nweights|read_fms()"; 
  #endif

  while (!net_def.eof()) {
    net_def >> string;
    if (!strcmp(string, "end")){
      return(CONTINUE);
    }
    else
    if (starts(string, "delta_lambda")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> delta_lambda;                    // delta_lambda
      #ifdef DEBUG
      cout << delta_lambda;
      #endif
    }
    else
    if (starts(string, "lambda")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> lambda;                    // lambda
      #ifdef DEBUG
      cout << lambda;
      #endif
    }
    else
    if (starts(string, "K")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> K;                    // K
      #ifdef DEBUG
      cout << K;
      #endif
    }
    else
    if (starts(string, "lparam_update")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> lparam_update;                    // lparam_update
      #ifdef DEBUG
      cout << lparam_update;
      #endif
    }
    else
    if (starts(string, "tpatterns")) {
      #ifdef DEBUG
      cout << "\n8" <<  string << "|";
      #endif
      net_def >> tpatterns;                    // tpatterns
      #ifdef DEBUG
      cout << tpatterns;
      #endif
    }
    else {
      return(put_error("Unbekannter Wert  -- read_fms."));
    }//else 
  }


  return(CONTINUE);
}


